#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,float *B0,float *B1,float *B2,int N){
for(int i=0;i<N;i++){
A0[i] = A0[i]-A0[i]-A0[i]*A0[i];
B0[i] = B1[i]/B1[i]/B1[i]/B2[i];
}
}

int main(int argc,char **argv) {
int size=248006;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
for(int i=0;i<248006;i++){
A0[i] = 78+i+1;
B0[i] = 65.7932176032+i+1;
B1[i] = 54.4498755735+i+1;
B2[i] = 57.7271440334+i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,B0,B1,B2,248006);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(B0);
free(B1);
free(B2);
printf("\n");return 0; }